#include <mpi.h>
#include <time.h>
#include <stdlib.h>


void main(int argc, char **argv)
{
	const int righe=5;
	const int colonne=5;

	int size, rank;

	int a[righe][colonne];
	int b[righe][colonne];
	int c[righe];
	int riga[righe];
	int colonna[colonne];

	MPI_Init(&argc,&argv);
	MPI_Comm_size(MPI_COMM_WORLD,&size);
	MPI_Comm_rank(MPI_COMM_WORLD,&rank);

	if (rank==0)
	{
		srand(time(NULL));

		/* INIZIALIZZAZIONE MATRICE A*/
		printf("Matrice a=\n");
		for(int i=0;i<righe;i++)
		{
			for(int j=0;j<colonne;j++)
				a[i][j]=rand()%20;
			for(int j=0;j<colonne;j++)
				printf("%d ",a[i][j]);
			printf("\n");
		}
				
		/* INIZIALIZZAZIONE MATRICE B*/
		printf("\nMatrice b=\n");
		for(int i=0;i<righe;i++)
		{
			for(int j=0;j<colonne;j++)
				b[i][j]=rand()%20;
			for(int j=0;j<colonne;j++)
				printf("%d ",b[i][j]);
			printf("\n");
		}

		/* INVIO DATI */
		for(int i=0;i<righe;i++)
		{
			for (int j=0;j<colonne;j++)
			{
				riga[j]=a[i][j];
				colonna[j]=b[j][i];
			}
		MPI_Send(riga,righe,MPI_INT,i+1,0,MPI_COMM_WORLD);
		MPI_Send(colonna,colonne,MPI_INT,i+1,0,MPI_COMM_WORLD);
		}	

		/* RICEZIONE DATI */
		for(int i=0;i<righe;i++)
			MPI_Recv(&c[i],1,MPI_INT,i+1,0,MPI_COMM_WORLD,MPI_STATUS_IGNORE);
		printf("Ho ricevuto\n");
		for(int i=0;i<righe;i++)
			printf("%d ",c[i]);
	}
	else
	{
		int c=0;
		MPI_Recv(riga,righe,MPI_INT,0,0,MPI_COMM_WORLD,MPI_STATUS_IGNORE);
		MPI_Recv(colonna,colonne,MPI_INT,0,0,MPI_COMM_WORLD,MPI_STATUS_IGNORE);
		for(int i=0;i<righe;i++)
			c+=riga[i]*colonna[i];
		printf("Sono il processo %d e ho calcolato il valore %d.",rank,c);
		MPI_Send(&c,1,MPI_INT,0,0,MPI_COMM_WORLD);
	}


	MPI_Finalize();
}